
    ----------------------------------------------------------------------------
    -- App für die Telemetriedaten der REX..A Empfänger umgeschrieben von A.Straßburg
    ----------------------------------------------------------------------------
    
collectgarbage()
--------------------------------------------------------------------------------

local model, owner = " ", " "
local playDone, sensorId, sensorPa
local sensid1, sensid2, sensid3, sensid4 , sensid5 , sensid6 = 0.0, 0.0, 0.0, 0.0 , 0.0 , 0.0


--------------------------------------------------------------------------------
-- Read translations
local function setLanguage()
    local lng=system.getLocale()
    local file = io.readall("Apps/Lang/REXA.jsn")
    local obj = json.decode(file)
    if(obj) then
        trans = obj[lng] or obj[obj.default]
    end
end


--------------------------------------------------------------------------------
-- Fenster Links oben , Roll
local function drawLetopbox(Value)

	lcd.drawText(40, 5, trans.Roll, FONT_MINI)
	lcd.drawText(120 - lcd.getTextWidth(FONT_MAXI,string.format("%.1f",Value)),14,string.format("%.1f°",Value),FONT_MAXI)
	
	lcd.drawRectangle(2,2,153,50,5)

end


--------------------------------------------------------------------------------

-- Fenster Links mitte  ,  Pitch
local function drawLemidbox(Value)	

	lcd.drawText(40, 56, trans.Pitch , FONT_MINI)
	lcd.drawText(120 - lcd.getTextWidth(FONT_MAXI,string.format("%.1f",Value)),66,string.format("%.1f°",Value),FONT_MAXI)
  
	lcd.drawRectangle(2,54,153,50,5)

end
--------------------------------------------------------------------------------

-- Fenster Links unten  ,  Yaw
local function drawLebotbox(Value)	

	lcd.drawText(40, 109, trans.Yaw, FONT_MINI)
	lcd.drawText(120 - lcd.getTextWidth(FONT_MAXI,string.format("%.1f",Value)),119,string.format("%.1f°",Value),FONT_MAXI)
    
	lcd.drawRectangle(2,107,153,50,5)

end

-- Fenster Rechts oben Beschleunigung
local function drawRitopbox(Value,val2)	 

	lcd.drawText(194, 5, trans.Gforce, FONT_MINI)
	lcd.drawText(254 - lcd.getTextWidth(FONT_MAXI,string.format("%.2f",Value)),15,string.format("%.2fG",Value),FONT_MAXI)
 	lcd.drawText(177,57, "Max-", FONT_MINI)
 	lcd.drawText(204,57, trans.Gforce, FONT_MINI)
	lcd.drawText(254 - lcd.getTextWidth(FONT_MAXI,string.format("%.2f",val2)),66,string.format("%.2fG",val2),FONT_MAXI)
 	lcd.drawText(161,46, "- - - - - - - - - - - - - - - - - - - - - - - - -", FONT_MINI)

	lcd.drawRectangle(160,2,153,102,5)
  --lcd.drawLine(159,52,310,52)
end

-- Fenster Rechts unten  Temperatur
local function drawRibotbox(Value)	

	lcd.drawText(194, 109, trans.rxtemp, FONT_MINI)
	lcd.drawText(255 - lcd.getTextWidth(FONT_MAXI,string.format("%.1f",Value)),119,string.format("%.1f°C",Value),FONT_MAXI)

	lcd.drawRectangle(160,107,153,50,5)

end
--------------------------------------------------------------------------------

-- Telemetriefenster 
local function Page1(width, height)

	drawLetopbox(sensid1)	          -- Roll
	drawLemidbox(sensid2)	          -- Pitch
	drawLebotbox(sensid3)	    	  -- Yaw
	drawRitopbox(sensid4,sensid5)  	  -- Beschleunigung , Max Beschleunigung
	drawRibotbox(sensid6)	  		  -- Temperatur 

end
--------------------------------------------------------------------------------
-- Take care of user's settings-changes
local function sensorChanged(value)
	sensorId  = sensorsAvailable[value].id
	system.pSave("sensorId", sensorId)
end

--------------------------------------------------------------------------------
local function setupForm(formID)
    -- Sensoren nur auflisten, wenn das Menü aktiv ist, um Speicher zur Laufzeit zu erhalten
    -- (bis zu 25% eingespart, wenn das Menü nicht geöffnet ist)
    sensorsAvailable = {}
    local available = system.getSensors();
    local list={}
    local curIndex=-1
    local descr = ""
    for index,sensor in ipairs(available) do 
		if(sensor.param == 0) then
		  	list[#list+1] = sensor.label
		  	sensorsAvailable[#sensorsAvailable+1] = sensor
		  	if(sensor.id==sensorId ) then
			  	curIndex=#sensorsAvailable
		  	end 
	  	end
    end
    
    local form, addRow, addLabel = form, form.addRow ,form.addLabel
    local addIntbox, addSelectbox = form.addIntbox, form.addSelectbox
    local addInputbox, addCheckbox = form.addInputbox, form.addCheckbox
    local addAudioFilebox, setButton = form.addAudioFilebox, form.setButton
	local setTitle, addSpacer = form.setTitle, form.addSpacer
    
	setTitle(trans.title)
				
	addSpacer(318,7)		

    addRow(2)
    addLabel({label = trans.selectsens, width=200})
    addSelectbox(list, curIndex, true, sensorChanged)
    	
	addRow(1)
	addLabel({label="Powered by A.Strassburg "..Version.."  ", font=FONT_MINI, alignRight=true})
    
    collectgarbage()
end

---------------------------------------------------------------------------------
local function loop()

		-- Read Sensor ID 1 REXA - Roll
		sensor = system.getSensorByID(sensorId, 15)
		if(sensor and sensor.valid) then
			sensid1 = sensor.value
     	end  
  
		-- Read Sensor ID 2 REXA - Pitch
		sensor = system.getSensorByID(sensorId, 16)
		if(sensor and sensor.valid) then 
			sensid2 = sensor.value
		end

		-- Read Sensor ID 3 REXA - Yaw
		sensor = system.getSensorByID(sensorId, 17)
		if(sensor and sensor.valid) then 
			sensid3 = sensor.value
		end	

		-- Read Sensor ID 4 + 5 REXA - Beschleunigung und Max
		sensor = system.getSensorByID(sensorId, 18)
		if(sensor and sensor.valid) then 
 			sensid4 = sensor.value
			if sensid5 < sensid4 then    --sensor.max
			    sensid5 = sensid4 
			end
		end
		
		-- Read Sensor ID 6 REXA - Temperatur
		sensor = system.getSensorByID(sensorId, 14)
		if(sensor and sensor.valid) then 
 			sensid6 = sensor.value
	    end
		
	    collectgarbage()  
end


-------------------------------------------------------------
local function init(code1)
    local pLoad, registerForm, registerTelemetry = system.pLoad, system.registerForm, system.registerTelemetry

	model = system.getProperty("Model")
	owner = system.getUserName()
	today = system.getDateTime()
	sensorId = pLoad("sensorId", 0)
    registerForm(1, MENU_APPS, trans.appName1, setupForm)
    registerTelemetry(1, trans.appName1.." "..model, 4, Page1) --registers a full size Window
    collectgarbage()
end
--------------------------------------------------------------------------------
Version = "1.0"
setLanguage()
collectgarbage()
return {init=init, loop=loop, author="A.Strassburg", version=Version, name=trans.appName1}